;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Anti Swimming Under The Level generator by Chdata/Fakescaper
;
; better version by Ladida
;
; This makes it so Mario can't move horizontally below the screen,
; without the need to place blocks. Useful for water levels.
; Shouldn't be hard to convert to levelasm if desired
;
; NOTE: As with all generators, not compatible with other generators (such as bullet bill generators, like the one on level 119) 
; If you want to use this along with another generator in the same level, just stick it in levelasm
;
; If you put this in a level that's not a water level, it still does the same thing but it's hardly noticeable and useless.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; sprite code JSL

print "INIT ",pc
print "MAIN ",pc
PHB : PHK : PLB
JSR code
PLB : RTL

; main sprite code

code:
REP #$10
LDY $80
CPY #$00D8 : BCC +
CPY #$0200 : BCS +
STZ $7B
+
SEP #$10 : RTS