SPRITE_WHEN_OFF = $01
SPRITE_WHEN_ON = $05

                    dcb "INIT"
	    RTL		

	                dcb "MAIN"			
	    JSR SPRITE_ROUTINE
                    RTL     



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SPRITE_ROUTINE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SPRITE_ROUTINE	  	
   
LDA #$00 	;\make sure that the teleport effect is done
CMP $0DB0	;|
BNE RETURN	;/

LDA $14AF
BEQ on		

LDA #$01	
CMP $14AF	
BEQ off	

off:



LDA #$04	;HERE IS THE BRIGHTNESS FOR NIGHT
STA $0DAE
LDA #$07	;HERE IS THE MUSIC FOR NIGHT
STA $1DFB
LDA #$00
STA $0701
LDA #$00
STA $0702


PHX
LDX #$0B

		

SpriteChangeLoop:

LDA $7FAB9E,x
CMP #SPRITE_WHEN_ON
BNE NotSPRITE1
JSR ChangeSPRITE1ToSPRITE2
NotSPRITE1:
DEX
BPL SpriteChangeLoop

PLX
RETURN:
RTS

ChangeSPRITE1ToSPRITE2:

	LDA $7FAB10,x
	AND #$08		; Check to see if the sprite's custom..
	BEQ NotCustom		; .. if bit 3 of $7FAB10 set, it is.

LDA #$01
STA $14C8,x

LDA #SPRITE_WHEN_OFF
STA $7FAB9E,x


JSL $07F7D2
JSL $0187A7
LDA #$08
STA $7FAB10,x
NotCustom:
RTS

on:

LDA #$0F	;HERE IS THE BRIGHTNESS FOR DAY
STA $0DAE
LDA #$02	;HERE IS THE MUSIC FOR DAY
STA $1DFB
LDA #$80
STA $0701
LDA #$73
STA $0702
RETURN

PHX
LDX #$0B

SpriteLoop:

LDA $7FAB9E,x
CMP #SPRITE_WHEN_OFF
BNE NotSPRITE2
JSR ChangeSPRITE2ToSPRITE1
NotSPRITE2:
DEX
BPL SpriteLoop

PLX
RTS

ChangeSPRITE2ToSPRITE1:
	LDA $7FAB10,x
	AND #$08		; Check to see if the sprite's custom..
	BEQ NotCustom		; .. if bit 3 of $7FAB10 set, it is.

LDA #$01
STA $14C8,x

LDA #SPRITE_WHEN_ON
STA $7FAB9E,x

JSL $07F7D2
JSL $0187A7
LDA #$08
STA $7FAB10,x
RTS





