PROJECTILE = $04		; Custom sprite to shoot
BUTTON = $40		;Button to press
GENSPEEDX = $20		; Shoot speed
GENPOSX = $0004		;X-pos Where it spawns from
GENPOSY = $000E		;Y-pos Where it spawns from
Sound = $06		; Sound to make when shot
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

dcb "INIT"

RTL

dcb "MAIN"
PHB
PHK
PLB
JSR SPRITE_ROUTINE
PLB
RTL

SPRITE_ROUTINE:
LDA $94
STA $E4,x
LDA $95
STA $14E0,x
LDA $96
STA $D8,x
LDA $97
STA $14D4,x

LDA $16
AND #BUTTON
BNE SHOOT
RETURN:
RTS

SHOOT
LDA #$20
STA $1558,x
;generate projectileGenCust
	JSL $02A9DE		;grab free sprite slot low priority
	BMI NoFire		;return if none left before anything else...

	LDA #Sound		;make fireball sound
	STA $1DFC

	JSR SetupCust		;run sprite generation routine
	NoFire
	BRA RETURN

SetupCust
	LDA #$08
	STA $14C8,y		;normal status, run init routine
	LDA #PROJECTILE

	PHX
	TYX
	STA $7FAB9E,x		;into sprite type table for custom sprites
	PLX
	
;set positions accordingly		
;restore gen sprite index

	LDA $14E0,x		;create base 16bit pos
	XBA
	LDA $E4,x

FacingRight
	LDA $14E0,x		;base xpos
	XBA
	LDA $E4,x
	REP #$20
	CLC
	ADC.w #GENPOSX		;add
	SEP #$20
	STA $E4,y		;store
	XBA
	STA $14E0,y
	
	LDA $14D4,x		;base ypos
	XBA
	LDA $D8,x
	REP #$20
	CLC
	ADC.w #GENPOSY		;add
	SEP #$20
	STA $D8,y		;store
	XBA
	STA $14D4,y

	TYX			;new sprite slot into X
	LDA #$1C ; Sprite = Bullet Bill
STA $9E,x
LDA #$01
STA $14C8,x
JSL $07F7D2 ; Reset sprite tables.

;set projectile speed according to Mario
	LDX $15E9		;restore sprite index

	LDA #GENSPEEDX
	STA $B6,y		;set xspeed
	
	RTS			;return