;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Layer 2 Loop, by yoshicookiezeus
; Makes layer 2 scroll downwards 12 tiles and then return
; Insert as a generator
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			dcb "INIT"
			dcb "MAIN"                                    
			PHB                     
			PHK                     
			PLB                     
			JSR Sprite_Main
			PLB                     
			RTL      

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Main sprite code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Sprite_Main:		LDA $9D		;\ If sprites locked,
			BNE Return	;/ branch

			STZ $1412	; Disable vertical scroll
			DEC $1468	; Scroll layer 2 downwards

			LDA $1468	;\ If not time for layer 2 to return,
			BNE Return	;/ branch
			LDA #$C0	;\ Reset layer 2 position
			STA $1468	;/

Return:			RTS		; return