;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Super Mario Bros 2 (USA) Key by Hamtaro126
; Uses extra bits: NO
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

print "INIT ",pc

INIT:	
        LDA #$09
	STA $14C8,x
	RTL

print "MAIN ",pc
MAIN:
	PHB
	PHK
	PLB
	JSR KeyGFXRt
	PLB
	RTL

KeyGFXRt:
	JSR GET_DRAW_INFO
	
        LDA $15F6,x ;Load Color
	STA $03     ;Store
	
	LDA $00     ;X Position
	STA $0300,y ;Store
	
	LDA $01     ;Y Position
	STA $0301,y ;Store

	LDA #$EC    ;Tile
        STA $0302,y ;Store

        LDA #$00    ;Other Attributes
	ORA $03     ;Color Attributes
	ORA $64     ;Level Attributes
	STA $0303,y ;Store
	
	LDY #$02    ;Tile Size (16x16)
        LDA #$00    ;Number of Sprites to Draw
	JSL $01B7B3
	RTS

GET_DRAW_INFO:		STZ $186C,x
			STZ $15A0,x
			LDA $E4,x
			CMP $1A
			LDA $14E0,x
			SBC $1B
			BEQ ON_SCREEN_X
			INC $15A0,x

ON_SCREEN_X:		LDA $14E0,x
			XBA
			LDA $E4,x
			REP #$20
			SEC
			SBC $1A
			CLC
			ADC #$0040
			CMP #$0180
			SEP #$20
			ROL A
			AND #$01
			STA $15C4,x
			BNE INVALID

			PHB
			PHK
			PLB
			LDY #$00
			LDA $1662,x
			AND #$20
			BEQ ON_SCREEN_LOOP
			INY
ON_SCREEN_LOOP:		LDA $D8,x
			CLC
			ADC SPR_T1,y
			PHP
 			CMP $1C
			ROL $00
			PLP
			LDA $14D4,x
			ADC #$00
			LSR $00
			SBC $1D
			BEQ ON_SCREEN_Y
			LDA $186C,x
			ORA SPR_T2,y
			STA $186C,x
ON_SCREEN_Y:		DEY
			BPL ON_SCREEN_LOOP

			LDY $15EA,x
			LDA $E4,x
			SEC
			SBC $1A
			STA $00
			LDA $D8,x
			SEC
			SBC $1C
			STA $01
			PLB
			RTS

INVALID:		
                        PLA
			PLA
			RTS

SPR_T1:			db $0C,$1C
SPR_T2:			db $01,$02
