                    dcb "INIT"
                    RTL		; no init

	                dcb "MAIN"
JSR Main
RTL
;;;;;;;;;;;;;
Main:
LDA #$00  ;\
STA $AA,x ;|
STA $B6,x ;/ no icky sprite moving stuff
;(I don't know if STZ $xx,x exists so I just took the default)

LDA $149A    ;\Kicking something?
ORA #$00     ;|If yes
BNE Kick     ;/Branch

LDA $1499          ;\Face screen?
ORA #$00           ;|If yes
BNE Facescreen     ;/Branch

LDA $0072          ;\Jumping?
ORA #$00           ;|If yes
BNE Walkframe2     ;/Branch to Walking frame 2
RTS

LDA $140D          ;\Spin jump?
ORA #$00           ;|If yes
BNE Facescreen     ;/Branch
RTS

Kick:
LDA #$AA    ;\
STA $0316   ;/ setting the lower tile
LDA $0317   ;\
ORA #$13    ;| setting the palette for the lower tile
STA $0317   ;/
LDA #$82    ;\ setting the tile for the head
STA $0312   ;/
LDA $0313   ;\
ORA #$13    ;| Setting the palette for the top tile
STA $0313   ;/
RTS

Walkframe2:
LDA #$A2    ;\
STA $0316   ;/ setting the lower tile
LDA $0317   ;\
ORA #$13    ;| setting the palette for the lower tile
STA $0317   ;/
LDA #$82    ;\ setting the tile for the head
STA $0312   ;/
LDA $0313   ;\
ORA #$13    ;| Setting the palette for the top tile
STA $0313   ;/
LDA $1470    ;\Carrying item?
ORA #$00     ;|If yes
BNE carry    ;/Branch
LDA $0073    ;\Ducking down?
ORA #$00     ;|If yes
BNE duck     ;/Branch
RTS

Facescreen:
LDA #$AC    ;\
STA $0316   ;/ setting the lower tile
LDA $0317   ;\
ORA #$13    ;| setting the palette for the lower tile
STA $0317   ;/
LDA #$8C    ;\ setting the tile for the head
STA $0312   ;/
LDA $0313   ;\
ORA #$13    ;| Setting the palette for the top tile
STA $0313   ;/
RTS

duck:
LDA #$80    ;\
STA $0316   ;/ setting the lower tile
LDA $0317   ;\
ORA #$13    ;| setting the palette for the lower tile
STA $0317   ;/
LDA #$88    ;\ setting the tile for the head
STA $0312   ;/
LDA $0313   ;\
ORA #$13    ;| Setting the palette for the top tile
STA $0313   ;/
RTS	

carry:
LDA #$A4    ;\
STA $0316   ;/ setting the lower tile
LDA $0317   ;\
ORA #$13    ;| setting the palette for the lower tile
STA $0317   ;/
LDA #$84    ;\ setting the tile for the head
STA $0312   ;/
LDA $0313   ;\
ORA #$13    ;| Setting the palette for the top tile
STA $0313   ;/
RTS	
