;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Timer-Based Coin Gainer - By Hailstorm                                                         ;
;                                                                                                ;
; This sprite increases Mario's coin count by one for every                                      ;
; second that passes.                                                                            ;
;                                                                                                ;
; Uses First Extra Bit: NO                                                                       ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Sprite Code JSL                                 ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        dcb "INIT"
        RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Main Sprite Code                                ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        dcb "MAIN"
        LDA $14
        AND #$3F
        BNE RETURN
        LDA $9D
        BNE RETURN
        INC $0DBF
        LDA #$01
        STA $1DFC
        LDA $0DBF
        CMP #$64
        BCC RETURN
        LDA #$05
        STA $1DFC
        STZ $0DBF
        INC $0DBE
        RTL

RETURN:
        RTL