	print "INIT ",pc
	;	JSR	SubHorzPos
	;	TYA	
	;	STA	$157C,x
		RTL	
	print "MAIN ",pc
		PHB	
		PHK	
		PLB	
		JSR	ZidaneBroMain
		PLB	
		RTL	

RunTable:	db $DE,$22
AccelTable:	db $FF,$01

Return:		RTS
ZidaneBroMain:
		JSR	Graphics
		JSR	SubOffscreen
		LDA	$9D
		BNE	Return
		LDA	$14C8,x
		CMP	#$08
		BNE	Return
		JSL	$81A7DC
		LDA	$1588,x
		AND	#$04
		BEQ	+
		STZ	$AA,x
+		LDA	$C2,x
		JSL	$8086DF
		dw	.NoWalk
		dw	.WalkLeft
		dw	.NoWalk
		dw	.WalkRight
		dw	.Shocked
		dw	.RedFace
		dw	.RunMario
		dw	.HeadAttack
		dw	.Cooldown

.NoWalk		LDA	#$02
		STA	$1602,x
		LDA	$1540,x
		BNE	+
		INC	$C2,x
		LDA	#$40
		STA	$1540,x
+		STZ	$B6,x
		JSR	CheckProx
		JSL	$81802A
		RTS	
.WalkRight
		STZ	$157C,x
		LDA	#$F8
		BRA	+
.WalkLeft
		LDA	#$01
		STA	$157C,x
		LDA	#$08
+		STA	$B6,x
		LDA	$14
		AND	#$07
		BNE	+
		JSR	UpdateWalkFrames
+		LDA	$1540,x
		BNE	+
		LDA	$C2,x
		CMP	#$03
		BNE	+++
		STZ	$C2,x
		BRA	++
+++		INC	$C2,x
++		LDA	#$10
		STA	$1540,x
+		JSR	CheckProx
		JSL	$81802A
		RTS	
.Shocked	LDA	#$03
		STA	$1602,x
		STZ	$B6,x
		LDA	$1540,x
		BNE	+
		INC	$C2,x
		LDA	#$40
		STA	$1540,x
+		RTS	
.RedFace	LDA	$1540,x
		BEQ	.ChangeState
		CMP	#$41
		BCS	.Wait
		CMP	#$31
		BCS	.TurnRed
		CMP	#$29
		BCS	.Blink
		LDA	#$06
		BRA	+
.TurnRed	LDA	#$04
		BRA	+
.Blink		CMP	#$30
		BNE	++
		LDA	#$0E
		STA	$1DF9
++		LDA	#$05
+		STA	$1602,x
		JSL	$81802A
.Wait		RTS	
.ChangeState	INC	$C2,x
		RTS			
.RunMario	JSR	SubHorzPos
		TYA	
		EOR	#$01
		STA	$157C,x
		TAY	
		LDA	$B6,x
		CMP.w	RunTable,y
		BEQ	+
		CLC	
		ADC.w	AccelTable,y
		STA	$B6,x
+		LDA	$1588,x
		AND	#$01
		BEQ	.nowallright
		LDA	#$E4
		STA	$B6,x
		LDA	#$EC
		STA	$AA,x
.nowallright	LDA	$1588,x
		AND	#$02
		BEQ	.nowallleft
		LDA	#$1C
		STA	$B6,x
		LDA	#$EC
		STA	$AA,x
.nowallleft	LDA	$1588,x
		AND	#$04
		BEQ	.nofloor
		LDA	$14
		AND	#$04
		BNE	.nofloor
		LDA	#$01
		STA	$1DF9
		JSR	SubSmoke
.nofloor	LDA	$14
		AND	#$03
		BNE	+
		LDA	$1602,x
		SEC	
		SBC	#$07
		STA	$1602,x
		JSR	UpdateWalkFrames
		LDA	$1602,x
		CLC	
		ADC	#$07
		STA	$1602,x
+		JSL	$81802A
		LDA	#$18
		JSR	SubProxVert
		BEQ	.NotNear
		LDY	$157C,x
		LDA.w	ProxTableX,y
		JSR	SubProxHorz
		BNE	.NotNear
		LDA	$1588,x
		AND	#$04
		BEQ	.NotNear
		INC	$C2,x
		LDA	#$04
		STA	$1540,x
		LDA	#$0A
		STA	$1602,x
.NotNear	RTS	
.HeadAttack	LDA	$1540,x
		BNE	+
		INC	$C2,x
		LDA	#$C0
		STA	$1540,x
		LDA	#$0B
		STA	$1602,x
+		RTS	
.Cooldown	LDA	$1540,x
		BNE	+
		STZ	$C2,x
		LDA	#$30
		STA	$1540,x
		LDA	#$02
		STA	$1602,x
+		RTS	

ProxTableX:	db $0C,$0A

Tilemap:	db $80,$82,$83,$00	;Walk 1
		db $80,$92,$93,$00	;Walk 2
		db $80,$86,$87,$00	;No walk
		db $84,$86,$87,$00	;Shocked
		db $88,$86,$87,$00	;Angry 1
		db $A8,$86,$87,$00	;Blink
		db $8A,$86,$87,$00	;Angry 2
		db $8A,$82,$83,$00	;Run 1
		db $8A,$92,$93,$00	;Run 2
		db $AA,$AC,$00,$00	;Prepare head attack
		db $A4,$A6,$96,$00	;Head attack
		db $A0,$A2,$8C,$00	;Cooldown
Size:		db $02,$00,$00,$00	;Walk 1
		db $02,$00,$00,$00	;Walk 2
		db $02,$00,$00,$00	;No walk
		db $02,$00,$00,$00	;Shocked
		db $02,$00,$00,$00	;Angry 1
		db $02,$00,$00,$00	;Blink
		db $02,$00,$00,$00	;Angry 2
		db $02,$00,$00,$00	;Run 1
		db $02,$00,$00,$00	;Run 2
		db $02,$02,$00,$00	;Prepare head attack
		db $02,$02,$00,$00	;Head attack
		db $02,$02,$00,$00	;Cooldown
YDisp:		db $F8,$08,$08
YDisp2:		db $00,$00
YDisp3:		db $F8,$00,$F8
XDisp:		db $00,$08,$00,$00
		db $00,$08,$E0,$00
XDisp2:		db $08,$00,$00
		db $F8,$00,$08
TilesNumTab:	db $02,$02,$02,$02
		db $02,$02,$02,$02
		db $02,$01,$02,$01
Graphics:
		JSR	GetDrawInfo
		LDA	$1602,x		;$06 = copy of 1602,x
		STA	$06
		ASL	#2		;$02 = frame index
		STA	$02
		LDA	$157C,x
		STA	$03		;$03 = x flip
		LDA	$15F6,x
		STA	$04		;$04 = pal
		LDX	$06
		LDA.w	TilesNumTab,x
		STA	$05		;$05 = num of tiles
		TAX	
-		PHX	
		LDA	$06
		CMP	#$09
		BEQ	.ydisp2
		CMP	#$0A
		BCC	+
		LDA.w	YDisp3,x
		BRA	++	
.ydisp2		LDA.w	YDisp2,x
		BRA	++
+		LDA.w	YDisp,x
++		CLC	
		ADC	$01
		STA	$0301,y
		PHX	
		TXA	
		LDX	$03
		BNE	+
		CLC	
		ADC	#$03
+		TAX	
		LDA	$06
		CMP	#$0A
		BCC	+
		LDA	XDisp2,x
		BRA	++
+		LDA.w	XDisp,x
++		CLC	
		ADC	$00
		STA	$0300,y
		PLX	
		TXA	
		CLC	
		ADC	$02
		TAX	
		LDA.w	Tilemap,x
		STA	$0302,y
		PHY	
		TYA	
		LSR	#2
		TAY	
		LDA.w	Size,x
		STA	$0460,y
		PLY	
		LDA	$04
		LDX	$03
		BEQ	+
		ORA	#$40
+		ORA	$64
		STA	$0303,y
		PLX	
		INY	#4
		DEX	
		BPL	-
		LDX	$15E9
		LDA	$05
		LDY	#$FF
		JSL	$81B7B3
		RTS	

CheckProx:	LDA	#$50
		JSR	SubProxHorz
		BNE	.NotNear
		STY	$06
		LDA	#$18
		JSR	SubProxVert
		BEQ	.NotNear
		LDA	$157C,x
		CMP	$06
		BEQ	.NotNear
		LDA	#$04
		STA	$C2,x
		LDA	#$28
		STA	$1540,x
.NotNear	RTS	

UpdateWalkFrames:
		LDA	$1602,x
		BNE	+
		INC	$1602,x
		RTS	
+		STZ	$1602,x
		RTS	

DirFix:		db $FF,$00

SubProxHorz:	STA	$00
		LDA	$E4,x
		SEC	
		SBC	$94
		PHA	
		JSR	SubHorzPos
		PLA	
		EOR	DirFix,y
		CMP	$00
		BCC	+
		RTS	
+		TDC
		RTS	

Shift:		db $0E,$02

SubSmoke:	LDY	#$03
.loop		LDA	$17C0,y
		BEQ	.found
		DEY	
		BPL	.loop
		RTS	
.found		LDA	#$03
		STA	$17C0,y
		PHY	
		LDY	$157C,x
		LDA	$E4,x
		CLC	
		ADC	Shift,y
		PLY	
		STA	$17C8,y
		LDA	$D8,x
		CLC	
		ADC	#$0B
		STA	$17C4,y
		LDA	#$12
		STA	$17CC,y
		RTS	
			
SubProxVert:	STA	$02
		LDA	$D8,x
		SEC	
		SBC	$96
		PHA	
		JSR	SubVertBody
		PLA	
		EOR	DirFix,y
		CMP	$02
		BCS	+
		LDA	#$01
		RTS	
+		TDC
		RTS	

SubVertBody:	LDY	#$00
		LDA	$96
		SEC	
		SBC	$D8,x
		STA	$0F
		LDA	$97
		SBC	$14D4,x
		BPL	$01
		INY	
		RTS	

SubHorzPos:	LDY	#$00
		LDA	$94
		SEC	
		SBC	$E4,x
		STA	$0F
		LDA	$95
		SBC	$14E0,x
		BPL	$01
		INY	
		RTS	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Subroutine: Off Screen.
;;; Handles the off screen situation such as deleting the sprite but allowing it
;;; to respawn if too far away, and also deleting it when it falls off the level.

Table1:	db $0C,$1C
Table2:	db $01,$02
Table3:	db $40,$B0
Table6:	db $01,$FF
Table4:	db $30,$C0,$A0,$C0,$A0,$F0,$60,$90,$30,$C0,$A0,$80,$A0,$40,$60,$B0
Table5:	db $01,$FF,$01,$FF,$01,$FF,$01,$FF,$01,$FF,$01,$FF,$01,$00,$01,$FF

SubOffscreen:
LDA #$00
STA $03

JSR SubIsOffscreen
BEQ Return2

LDA $5B
LSR
BCS VerticalLevel
LDA $D8,x
CLC
ADC #$50
LDA $14D4,x
ADC #$00
CMP #$02
BPL EraseSprite
LDA $167A,x
AND #$04
BNE Return2
LDA $13
AND #$01
ORA $03
STA $01
TAY
LDA $1A
CLC
ADC Table4,y
ROL $00
CMP $E4,x
PHP
LDA $1B
LSR $00
ADC Table5,y
PLP
SBC $14E0,x
STA $00
LSR $01
BCC Label20
EOR #$80
STA $00
Label20:
LDA $00
BPL Return2

EraseSprite:
LDA $14C8,x
CMP #$08
BCC KillSprite
LDY $161A,x
CPY #$FF
BEQ KillSprite
LDA #$00
STA $1938,y
KillSprite:
STZ $14C8,x
Return2:
RTS

VerticalLevel:

LDA $167A,x
AND #$04
BNE Return2
LDA $13
LSR
BCS Return2
AND #$01
STA $01
TAY
LDA $1C
CLC
ADC Table3,y
ROL $00
CMP $D8,x
PHP
LDA $1D
LSR $00
ADC Table6,y
PLP
SBC $14D4,x
STA $00
LDY $02
BEQ Label22
EOR #$80
STA $00
Label22:
LDA $00
BPL Return2
BMI EraseSprite

SubIsOffscreen:
LDA $15A0,x
ORA $186C,x
RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Subroutine: Get Draw Info
;;; Gets the information to let sprites draw their graphics properly,
;;; such as the horizontal and vertical positioning.

GetDrawInfo:

STZ $186C,x
STZ $15A0,x
LDA $E4,x
CMP $1A
LDA $14E0,x
SBC $1B
BEQ OnscreenX
INC $15A0,x
OnscreenX:
LDA $14E0,x
XBA
LDA $E4,x
REP #$20
SEC
SBC $1A
CLC
ADC.w #$0040
CMP #$0180
SEP #$20
ROL A
AND #$01
STA $15C4,x
BNE Invalid

LDY #$00
LDA $1662,x
AND #$20
BEQ OnscreenLoop
INY
OnscreenLoop:
LDA $D8,x
CLC
ADC Table1,y
PHP
CMP $1C
ROL $00
PLP
LDA $14D4,x
ADC #$00
LSR $00
SBC $1D
BEQ OnscreenY
LDA $186C,x
ORA Table2,y
STA $186C,x
OnscreenY:
DEY
BPL OnscreenLoop
LDY $15EA,x
LDA $E4,x
SEC
SBC $1A
STA $00
LDA $D8,x
SEC
SBC $1C
STA $01
RTS

Invalid:
PLA
PLA
RTS