;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Inverted podoboo
;
;Uses first extra bit: NO
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			incsrc definition.asm

;;;;;;;;;;;;;;;;;;;;;;;;;
;Sprite data		;
;;;;;;;;;;;;;;;;;;;;;;;;;

TABLE_00		dcb $90,$E0

;;;;;;;;;;;;;;;;;;;;;;;;;
;INIT & MAIN		;
;;;;;;;;;;;;;;;;;;;;;;;;;

			dcb "INIT"
			LDA $D8,x
			STA $1528,x
			LDA $14D4,x
			STA $151C,x
LAVA_CHECK		LDA $D8,x
			SEC
			SBC #$10
			STA $D8,x
			LDA $14D4,x
			SBC #$00
			STA $14D4,x
			JSL $819138
			LDA $164A,x
			BEQ LAVA_CHECK
			RTL

			dcb "MAIN"
			PHB
			PHK
			PLB
			JSR SPRITE_ROUTINE
			PLB
			RTL

;;;;;;;;;;;;;;;;;;;;;;;;;
;Main sprite routine	;
;;;;;;;;;;;;;;;;;;;;;;;;;

SPRITE_ROUTINE		LDA $14C8,x
			CMP #$08
			BNE RETURN

			STZ $15D0,x
			LDA $1540,x
			BEQ SPRITE_MAIN
			STZ $1534,x
			STA $15D0,x
			DEC A
			BNE RETURN
			LDA #$27
			STA $1DFC
RETURN			RTS

SPRITE_MAIN		JSR SPRITE_GFX
			LDA $9D
			BNE RETURN

			LDA $AA,x
			BNE LABEL_04
			LDA #$F0
			STA $AA,x

LABEL_04		JSL $01A7DC
			INC $1570,x
			LDA $1570,x
			LSR A
			LSR A
			AND #$01
			STA $1602,x

			LDA $15F6,x
			AND #$7F
			LDY $AA,x
			BMI NOT_INVERTED
			INC $1602,x
			INC $1602,x
			ORA #$80
NOT_INVERTED		STA $15F6,x

			JSL $019138
			LDA $164A,x
			BEQ LABEL_00
			LDA $AA,x
			BPL LABEL_00
			JSL $01ACF9
			AND #$3F
			ADC #$60
			STA $1540,x
			LDA $1528,x
			SEC
			SBC $D8,x
			STA $00
			LDA $151C,x
			SBC $14D4,x
			LSR A
			ROR $00
			LDA $00
			LSR A
			LSR A
			LSR A
			PHX
			TAX
			LDA $01E07B,x
			PLX
			EOR #$FF
			INC A
			BPL STORE_AA
			STA $1564,x
STORE_AA		STA $AA,x
			RTS

LABEL_00		JSL $01801A
			LDA $14
			AND #$07
			ORA $C2,x
			BNE LABEL_01
			JSL $0285DF
LABEL_01		LDA $1564,x
			BNE LABEL_02
			LDA $AA,x
			BPL LABEL_03
			LDY $C2,x
			CMP TABLE_00,y
			BCC LABEL_02
LABEL_03		DEC $AA,x
			DEC $AA,x

LABEL_02		JSR SubOffScreen

			REP #$20
			LDA.w #$8600
			STA $0D8B
			LDA.w #$8800
			STA $0D95
			SEP #$20
			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;
;Sprite GFX		;
;;;;;;;;;;;;;;;;;;;;;;;;;

SPRITE_GFX		LDA $1602,x
			ASL A
			ASL A
			STA $02

			LDA $15F6,x
			ORA $64
			STA $03

			JSR GetDrawInfo

			PHX
			LDX #$03
GFX_LOOP		PHX

			LDA $00
			CLC
			ADC $019CD3,x
			STA $0300,y

			LDA $01
			CLC
			ADC $019CD7,x
			STA $0301,y

			LDA $019CDF,x
			ORA $03
			STA $0303,y

			TXA
			ORA $02
			TAX
			LDA $019C35,x
			STA $0302,y

			PLX
			INY
			INY
			INY
			INY
			DEX
			BPL GFX_LOOP
			PLX
			LDY #$00
			LDA #$03
			JSL $81B7B3
			RTS