;-;-;-;-;-;-;-;-;-;-;-;-;-;-;-;-;
;Alternating Layer 2 interaction;
;      Made by MSAhm3d59113	;
;-;-;-;-;-;-;-;-;-;-;-;-;-;-;-;-;
;Requires the level to be in Mode 01, 02, 0F or 1F.
;Setting the level mode to one where the interaction is false from the start
;may cause the background colour to not change if you do not set it to the same one.
;To fix, just change the colour to the disabled colour, or not have a colour change.
;Also, does not work on vertical levels.
;My first custom sprite, enjoy!
;Wow, there are sure a lot of comments, aren't there?

print "INIT ", pc
RTL
print "MAIN ", pc
LDA $14		;load frame counter
CMP #$FF	;compare (can really be anything)
BEQ Check	;if equal, check it
RTL		;else, go away

Check:
LDA $5B		;load screen mode
BNE Disable	;If there is interaction, branch
LDA #$80	;load layer 2 collision value
STA $5B		;store it to the screen mode
REP #$20	;to 16 bit!
LDA #$5D80	;load the colour 'blue' (0060b8 hex)
STA $0701	;store it to the back colour
SEP #$20	;back to 8 bit
LDA #$0B	;load the on/off sound effect
STA $1DF9	;play it
RTL		;we're done here

Disable:
STZ $5B		;disable interaction
REP #$20	;to 16 bit!
LDA #$0CFB	;load the colour 'red' (d83818 hex)
STA $0701	;store it to the back colour
SEP #$20	;back to 8 bit
LDA #$0B	;load the on/off sound effect
STA $1DF9	;play it
RTL		;we're done here