;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Autowalk									;
; Made by Ramp202								;
; Description: Basically it's like the same autowalk sprite but instead of...	;
; pushing mario into the wall, it will stop mario. I also included a.........	;
; option for the Extra Bit if you want Mario to go left.			;
;										;
; Extra Bit: YES								;
; If it's not set, mario will go left, otherwise he goes right			;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	dcb "INIT"
		LDA $7FAB10,x	;\
		BIT #$04	;| Check Extra Bit
		BEQ LookLeft	;/
		RTL
LookLeft:
		STZ $76		; Set Mario's Direction to left
		RTL		; Return

	dcb "MAIN"
		PHB
		PHK
		PLB
		JSR SpriteCode
		PLB
		RTL

;;;;;;;;;;;;;;;;;;;;
; Sprite MAIN Code ;
;;;;;;;;;;;;;;;;;;;;

SpriteCode:
		LDA $7FAB10,x	;\
		BIT #$04	;| Check Extra Bit
		BEQ Left	;/
		LDA #$10	;\ Make mario Autowalk
		STA $7B		;/
		LDA $1493	;\
		CMP #$01	;| Check if mario touched the goal
		BCS Erase	;/
Back:
		LDA $77		;\ Check if mario is touching
		CMP #$03	;| the side of an object.
		BNE Return	;/
		STZ $7B
Return:
		RTS

Erase:
		STZ $14C8,x
		RTS
Left:
		LDA #$F0
		STA $7B
		BRA Back