;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Sumo brother disassembly
; By nekoh
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    print "INIT ",pc                       
                    RTL        


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main code 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                           
                    print "MAIN ",pc
                    PHB                       
                    LDA #$02                
                    PHA                       
                    PLB                       
                    JSL Layer3SmashMain     
                    PLB                       
                    RTL                       ; Return 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite code JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Layer3SmashMain:    JSL $00FF61         
                    LDA $9D     
                    BNE Return02D444          
                    JSR CODE_02D49C         
                    LDY #$00                
                    LDA $17BD                       
                    CLC                       
                    ADC $E4,X       
                    STA $E4,X       
                    TYA                       
                    ADC $14E0,X     
                    STA $14E0,X     
                    LDA $C2,X     
                    JSL $0086DF          

Layer3SmashPtrs:    dw CODE_02D419           
                    dw CODE_02D445           
                    dw CODE_02D455           
                    dw CODE_02D481           
                    dw CODE_02D489           

CODE_02D419:        LDA $18BF               
                    BEQ CODE_02D422           
                    JSR OffScrEraseSprBnk2  
                    RTS                       ; Return 

CODE_02D422:        LDA $1540,X             
                    BNE Return02D444          
                    INC $C2,X     
                    LDA #$80                
                    STA $1540,X             
                    JSL $01ACF9             
                    AND #$3F                
                    ORA #$80                
                    STA $E4,X       
                    LDA #$FF                
                    STA $14E0,X     
                    STZ $D8,X       
                    STZ $14D4,X     
                    STZ $AA,X    ; Sprite Y Speed = 0 
Return02D444:       RTL                       ; Return 

CODE_02D445:        LDA $1540,X             
                    BEQ CODE_02D452           
                    LDA #$04                
                    STA $AA,X    
                    JSR UpdateYPosNoGrvty   
                    RTL                       ; Return 

CODE_02D452:        INC $C2,X     
                    RTL                       ; Return 

CODE_02D455:        JSR UpdateYPosNoGrvty   
                    LDA $AA,X    
                    BMI CODE_02D460           
                    CMP #$40                
                    BCS CODE_02D465           
CODE_02D460:        CLC                       
                    ADC #$07                
                    STA $AA,X    
CODE_02D465:        LDA $D8,X       
                    CMP #$A0                
                    BCC Return02D480          
                    AND #$F0                
                    STA $D8,X       
                    LDA #$50                ; \ Set ground shake timer 
                    STA $1887  ; / 
                    LDA #$09                ; \ Play sound effect 
                    STA $1DFC               ; / 
                    LDA #$30                
                    STA $1540,X             
                    INC $C2,X     
Return02D480:       RTL                       ; Return 

CODE_02D481:        LDA $1540,X             
                    BNE Return02D488          
                    INC $C2,X     
Return02D488:       RTL                       ; Return 

CODE_02D489:        LDA #$E0                
                    STA $AA,X    
                    JSR UpdateYPosNoGrvty   
                    LDA $D8,X       
                    BNE Return02D49B          
                    STZ $C2,X     
                    LDA #$A0                
                    STA $1540,X             
Return02D49B:       RTL                       ; Return 

CODE_02D49C:        LDA #$00                
                    LDY $19      
                    BEQ CODE_02D4A8           
                    LDY $73         
                    BNE CODE_02D4A8           
                    LDA #$10                
CODE_02D4A8:        CLC                       
                    ADC $D8,X       
                    CMP $80                   
                    BCC CODE_02D4EF           
                    LDA $E4,X       
                    STA $00                   
                    LDA $14E0,X     
                    STA $01                   
                    REP #$20                  ; Accum (16 bit) 
                    LDA $7E                   
                    CLC                       
                    ADC $00                   
                    SEC                       
                    SBC #$0030              
                    CMP #$0090              
                    BCS CODE_02D4EF           
                    SEC                       
                    SBC #$0008              
                    CMP #$0080              
                    SEP #$20                  ; Accum (8 bit) 
                    BCS CODE_02D4E5           
                    LDA $72          
                    BNE CODE_02D4DC           
                    JSL $00F5B7           
                    RTS                       ; Return 

CODE_02D4DC:        STZ $7D       
                    LDA $AA,X    
                    BMI Return02D4E4          
                    STA $7D       
Return02D4E4:       RTS                       ; Return 

CODE_02D4E5:        PHP                       
                    LDA #$08                
                    PLP                       
                    BPL CODE_02D4ED           
                    LDA #$F8                
CODE_02D4ED:        STA $7B       
CODE_02D4EF:        SEP #$20                  ; Accum (8 bit) 
                    RTS                       ; Return 


DATA_02D4F2:        db $80,$40,$20,$10,$08,$04,$02,$01

                    LDY #$00                
                    LDA $94         
                    SEC                       
                    SBC $E4,X       
                    STA $0F                   
                    LDA $95       
                    SBC $14E0,X     
                    BPL Return02D50B          
                    INY                       
Return02D50B:       RTS                       ; Return 

                    LDY #$00                
                    LDA $96         
                    SEC                       
                    SBC $D8,X       
                    STA $0E                   
                    LDA $97       
                    SBC $14D4,X     
                    BPL Return02D51D          
                    INY                       
Return02D51D:       RTS                       ; Return 


DATA_02D51E:                      db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
                                  db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
                                  db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
                                  db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
                                  db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
                                  db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
                                  db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
                                  db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
                                  db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
                                  db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
                                  db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
                                  db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
                                  db $FF

DATA_02D57F:        db $FF,$13,$14,$15,$16,$17,$18,$19

                    JSR CODE_02D5E4         
                    LDA $14C8,X             
                    CMP #$02                
                    BEQ Return02D5A3          
                    LDA $9D     
                    BNE Return02D5A3          
                    JSR SubOffscreen0Bnk2   
                    LDA #$E8                
                    STA $B6,X    
                    JSR UpdateXPosNoGrvty   
                    JSL $01A7DC  
Return02D5A3:       RTS                       ; Return 


DATA_02D5A4:                      db $00,$10,$20,$30,$00,$10,$20,$30
                                  db $00,$10,$20,$30,$00,$10,$20,$30
DATA_02D5B4:                      db $00,$00,$00,$00,$10,$10,$10,$10
                                  db $20,$20,$20,$20,$30,$30,$30,$30
BanzaiBillTiles:                  db $80,$82,$84,$86,$A0,$88,$CE,$EE
                                  db $C0,$C2,$CE,$EE,$8E,$AE,$84,$86
DATA_02D5D4:                      db $33,$33,$33,$33,$33,$33,$33,$33
                                  db $33,$33,$33,$33,$33,$33,$B3,$B3

CODE_02D5E4:        JSR GET_DRAW_INFO        
                    PHX                       
                    LDX #$0F                
CODE_02D5EA:        LDA $00                   
                    CLC                       
                    ADC DATA_02D5A4,X       
                    STA $0300,Y         
                    LDA $01                   
                    CLC                       
                    ADC DATA_02D5B4,X       
                    STA $0301,Y         
                    LDA BanzaiBillTiles,X   
                    STA $0302,Y          
                    LDA DATA_02D5D4,X       
                    STA $0303,Y          
                    INY                       
                    INY                       
                    INY                       
                    INY                       
                    DEX                       
                    BPL CODE_02D5EA           
                    PLX                       
                    LDY #$02                
                    LDA #$0F                
                    JSL $01B7B3      
                    RTS                       ; Return  


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Update Y Position With No Gravity
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

UpdateXPosNoGrvty:  TXA                       ; \ Adjust index so we use X values rather than Y 
                    CLC                       ;  | 
                    ADC #$0C                  ;  | 
                    TAX                       ; / 
                    JSR UpdateYPosNoGrvty   
                    LDX $15E9                 ; X = sprite index 
                    RTS                       ; Return 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Update X Position With No Gravity
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

UpdateYPosNoGrvty:  LDA $AA,X                 ; \ $14EC or $14F8 += 16 * speed 
                    ASL                       ;  | 
                    ASL                       ;  | 
                    ASL                       ;  | 
                    ASL                       ;  | 
                    CLC                       ;  | 
                    ADC $14EC,X               ;  | 
                    STA $14EC,X               ; / 
                    PHP                       
                    PHP                       
                    LDY #$00                
                    LDA $AA,X                 ; \ Amount to move sprite = speed / 16 
                    LSR                       ;  | 
                    LSR                       ;  | 
                    LSR                       ;  | 
                    LSR                       ; / 
                    CMP #$08                  ; \ If speed was negative... 
                    BCC CODE_02D2B2           ;  | 
                    ORA #$F0                  ;  | ...set high bits 
                    DEY                       ; / 
CODE_02D2B2:        PLP                       
                    PHA                       ; \ Add to position 
                    ADC $D8,X                 ;  | 
                    STA $D8,X                 ;  | 
                    TYA                       ;  | 
                    ADC $14D4,X               ;  | 
                    STA $14D4,X               ;  | 
                    PLA                       ; / 
                    PLP                       
                    ADC #$00                
                    STA $1491                 ; $1491 = amount sprite was moved 
                    RTS                       ; Return 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Get Draw Info
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TABLE1:             db $0C,$1C
TABLE2:             db $01,$02

GET_DRAW_INFO:      STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X:        LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC #$0040            ;  |
                    CMP #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP:     LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y:        DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID:            PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Sprite Graphics Routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DATA_02D003:        db $40,$B0
DATA_02D005:        db $01,$FF
DATA_02D007:        db $30,$C0,$A0,$C0,$A0,$70,$60,$B0
DATA_02D00F:        db $01,$FF,$01,$FF,$01,$FF,$01,$FF


SubOffscreen0Bnk2:  STZ $03                   ; / 
                    JSR IsSprOffScreenBnk2  ; \ if sprite is not off screen, return 
                    BEQ Return02D090          ; / 
                    LDA $5B     ; \  vertical level 
                    AND #$01                ;  | 
                    BNE VerticalLevelBnk2     ; / 
                    LDA $03                   
                    CMP #$04                
                    BEQ CODE_02D04D           
                    LDA $D8,X       ; \ 
                    CLC                       ;  | 
                    ADC #$50                ;  | if the sprite has gone off the bottom of the level... 
                    LDA $14D4,X     ;  | (if adding 0x50 to the sprite y position would make the high byte >= 2) 
                    ADC #$00                ;  | 
                    CMP #$02                ;  | 
                    BPL OffScrEraseSprBnk2    ; /    ...erase the sprite 
                    LDA $167A,X   ; \ if "process offscreen" flag is set, return 
                    AND #$04                ;  | 
                    BNE Return02D090          ; / 
CODE_02D04D:        LDA $13      
                    AND #$01                
                    ORA $03                   
                    STA $01                   
                    TAY                       
                    LDA $1A    
                    CLC                       
                    ADC DATA_02D007,Y       
                    ROL $00                   
                    CMP $E4,X       
                    PHP                       
                    LDA $1B    
                    LSR $00                   
                    ADC DATA_02D00F,Y       
                    PLP                       
                    SBC $14E0,X     
                    STA $00                   
                    LSR $01                   
                    BCC CODE_02D076           
                    EOR #$80                
                    STA $00                   
CODE_02D076:        LDA $00                   
                    BPL Return02D090          
OffScrEraseSprBnk2: LDA $14C8,X             ; \ If sprite status < 8, permanently erase sprite 
                    CMP #$08                ;  | 
                    BCC OffScrKillSprBnk2     ; / 
                    LDY $161A,X ; \ Branch if should permanently erase sprite 
                    CPY #$FF                ;  | 
                    BEQ OffScrKillSprBnk2     ; / 
                    LDA #$00                ; \ Allow sprite to be reloaded by level loading routine 
                    STA $1938,Y ; / 
OffScrKillSprBnk2:  STZ $14C8,X             ; Erase sprite 
Return02D090:       RTS                       ; Return 

VerticalLevelBnk2:  LDA $167A,X   ; \ If "process offscreen" flag is set, return 
                    AND #$04                ;  | 
                    BNE Return02D090          ; / 
                    LDA $13      ; \ Return every other frame 
                    LSR                       ;  | 
                    BCS Return02D090          ; / 
                    AND #$01                
                    STA $01                   
                    TAY                       
                    LDA $1C    
                    CLC                       
                    ADC DATA_02D003,Y       
                    ROL $00                   
                    CMP $D8,X       
                    PHP                       
                    LDA $1D  
                    LSR $00                   
                    ADC DATA_02D005,Y       
                    PLP                       
                    SBC $14D4,X     
                    STA $00                   
                    LDY $01                   
                    BEQ CODE_02D0C3           
                    EOR #$80                
                    STA $00                   
CODE_02D0C3:        LDA $00                   
                    BPL Return02D090          
                    BMI OffScrEraseSprBnk2    
IsSprOffScreenBnk2: LDA $15A0,X 
                    ORA $186C,X 
                    RTS                       ; Return 