;	;	;	;	;	;	;	;	;	;	;	;
;
;	~Ultimaximus
;	Insert as a generator
;	Does not use extra bit
;	Will kill Mario instantly if he enters the level with 0 coins
;	Thus the best placement is in a level after the entrance level, providing some coins
;	Limits max coins to 98
;	Coded from scratch, I did not look at Superyoshi's "Money Is Life"
;	Credit much preferred
;
;	;	;	;	;	;	;	;	;	;	;	;



dcb "INIT"
dcb "MAIN"


LDA $0DBF	; Coins
CMP #99		; If 99 coins...
BNE Bleh
DEC $0DBF	; Decrease by one to prevent 1-up via coins, and A0 from showing up
Bleh:


LDA $0DBF	; Coins
BEQ Death


LDA $14AF	; ON/OFF
CMP #$01
BEQ Continue	; Continue if 01-FF (OFF)


LDA $13		; Frame count
BEQ ONOFFSwitch


Continue:
LDA $13		; Frame count
AND #$3F
BNE Return	; Continue only once per second


LDA $14AF	; ON/OFF
BEQ ON		; If 00 (ON), branch


;OFF:
DEC $0DBF
LDA #$2A	; Incorrect Sound
STA $1DFC
BRA Return



ON:
INC $0DBF
LDA #$01	; Coin sound
STA $1DFC
BRA Return



Death:
LDA $188A	; Prevents Death from running every frame
BNE Return
JSL $F606	; Die Mario, die!
LDA #$01	
STA $188A	; Prevents death from running every frame
BRA Return


ONOFFSwitch:
LDA #$01
STA $14AF	; Switch OFF
LDA #$1C
STA $1DFC	; Play sound


Return:
RTL