;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Air bubble shooter
;;   by TheBiob
;; Description: This shoots air bubbles. The shooter will spawn the bubbles on a set timer
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!time	= $50 ; How long the shooter waits until it generates a new sprite (Decrements twice per frame)

;;;;;;;;;;;;;;;
; Sprite Code ;
;;;;;;;;;;;;;;;

	print "INIT ",pc
	print "MAIN ",pc
		LDA $17AB,x	; \ Wait until it's time to shoot
		BNE .return	; /
		LDA #!time	; \ Set new timer
		STA $17AB,x	; /
		
		LDA $178B,x             ; \ don't generate if off screen vertically
		CMP $1C                 ;  |
		LDA $1793,x             ;  |
		SBC $1D                 ;  |
		BNE .return             ; /
		LDA $179B,x             ; \ don't generate if off screen horizontally
		CMP $1A                 ;  |
		LDA $17A3,x             ;  |
		SBC $1B                 ;  |
		BNE .return             ; / 
		
		LDY #$08
.loop	LDA $170B,y
		BEQ .slotfound
		DEY : BPL .loop
.return
	RTL
.slotfound
		LDA #$12	; \ Set ex sprite type to Water bubble
		STA $170B,y	; /
		
		LDA $179B,x	; \ set x position for new sprite
		STA $171F,y	;  |
		LDA $17A3,x	;  |
		STA $1733,y	; /
		LDA $178B,x	; \ set y position for new sprite
		STA $1715,y	;  |
		LDA $1793,x	;  |
		STA $1729,y	; /
		
		RTL	; > Return