; Best Teleporter made by Ixtab
; defines are below 
!free = $1DFD	; point this to somewhere with 2 free bytes (so this would use $0660 and $0661)
!SpriteNumber = $10 	; enter the sprite number from your txt file that you insert this one as
Levelpointer:	; this is the table for when the bit is not test
dw $0105,$0106,$0107,$0108,$0109,$010A,$010B,$010C ; x postions 1-8
dw $010D,$010E,$010F,$0110,$0111,$0112,$0113,$0114	; x positions 9-16
; as you can see, it's the level you want to go to or the secondary exit
Levelpointer2:	; this is for when the extra bit IS set
dw $0115,$0116,$0117,$0118,$0119,$011A,$011B,$011C ; x postions 1-8
dw $011D,$011E,$011F,$0120,$0121,$0122,$0123,$0124 ; x positions 9-16

; next is the properties for the exit
; $02 = secondary exit
; $08 = water level
; $0A = secondary exit & water level
!prop0 = $00	; position 1
!prop1 = $00	; 2
!prop2 = $00	; 3
!prop3 = $00	; 4
!prop4 = $00	; etc
!prop5 = $00
!prop6 = $00
!prop7 = $00
!prop8 = $00
!prop9 = $00
!propA = $00
!propB = $00
!propC = $00
!propD = $00
!propE = $00
!propF = $00
!xtra0 = $0A	; position 1 when extra bit is set
!xtra1 = $00	; 2 when extra bit is set
!xtra2 = $00	; 3
!xtra3 = $00	; etc
!xtra4 = $00
!xtra5 = $00
!xtra6 = $00
!xtra7 = $00
!xtra8 = $00
!xtra9 = $00
!xtraA = $00
!xtraB = $00
!xtraC = $00
!xtraD = $00
!xtraE = $00
!xtraF = $00

;==================================================================

print "INIT ",pc
LDA $E4,x
LSR
LSR
LSR
LSR
STA $1504,x
LDA $7FAB10,x
STA $1FD6,x
RTL

print "MAIN ",pc
PHB
PHK
PLB
JSR code
PLB
RTL

State123:
JMP State

code:
; STA $7FFFFF 
STX $08
LDA $1FD6,x
STA $01
LDA $1504,x
STA $00
PHX
LDX #$0B
Loop:
CPX $08
BEQ Nope
LDA $14C8,x
BNE State123
Nope:
DEX
BPL Loop
Nosprites:
LDA $5B
BEQ Label1
LDX $97
BRA Label2
Label1:
LDX $95
Label2:
REP #$20
LDA $01
AND #$0004
BNE Set
LDA $00
ASL A
TAY
LDA Levelpointer,y
BRA Label3
Set:
LDA $00
ASL A
TAY
LDA Levelpointer2,y
Label3:
STA !free
LDA !free
SEP #$20
STA $19B8,x
XBA
ORA #$04
STA $19D8,x
JSR Exitprop
TSB $19D8
TSB $19D9
TSB $19DA
TSB $19DB
TSB $19DC
TSB $19DD
TSB $19DE
TSB $19DF
TSB $19E0
TSB $19E1
TSB $19E2
TSB $19E3
TSB $19E4
TSB $19E5
TSB $19E6
TSB $19E7
TSB $19E8
TSB $19E9
TSB $19EA
TSB $19EB
TSB $19EC
TSB $19ED
TSB $19EE
TSB $19EF
TSB $19F0
TSB $19F1
TSB $19F2
TSB $19F3
TSB $19F4
TSB $19F5
TSB $19F6
TSB $19F7
LDA #$06			;\
STA $71				; |not my code
STZ $89				; |
STZ $88				;/
BRA Label4

State:
LDA $7FAB9E,x
CMP #!SpriteNumber
BNE Label4
LDA $1686,x
CMP #$FF
BNE Label4
BRA NoSprites123
Label4:
PLX
RTS

NoSprites123:
JMP Nosprites

Exitprop:
PHX
LDA $01
AND #$04
BNE Set2
LDA $00
ASL A
TAX
JMP (getprop,x)
Set2:
LDA $00
ASL A
TAX
JMP (getpro2,x)

getprop:
dw prop0perty
dw prop1perty
dw prop2perty
dw prop3perty
dw prop4perty
dw prop5perty
dw prop6perty
dw prop7perty
dw prop8perty
dw prop9perty
dw propAperty
dw propBperty
dw propCperty
dw propDperty
dw propEperty
dw propFperty

getpro2:
dw xtra0perty
dw xtra1perty
dw xtra2perty
dw xtra3perty
dw xtra4perty
dw xtra5perty
dw xtra6perty
dw xtra7perty
dw xtra8perty
dw xtra9perty
dw xtraAperty
dw xtraBperty
dw xtraCperty
dw xtraDperty
dw xtraEperty
dw xtraFperty

prop0perty:
PLX
LDA #!prop0
RTS
prop1perty:
PLX
LDA #!prop1
RTS
prop2perty:
PLX
LDA #!prop2
RTS
prop3perty:
PLX
LDA #!prop3
RTS
prop4perty:
PLX
LDA #!prop4
RTS
prop5perty:
PLX
LDA #!prop5
RTS
prop6perty:
PLX
LDA #!prop6
RTS
prop7perty:
PLX
LDA #!prop7
RTS
prop8perty:
PLX
LDA #!prop8
RTS
prop9perty:
PLX
LDA #!prop9
RTS
propAperty:
PLX
LDA #!propA
RTS
propBperty:
PLX
LDA #!propB
RTS
propCperty:
PLX
LDA #!propC
RTS
propDperty:
PLX
LDA #!propD
RTS
propEperty:
PLX
LDA #!propE
RTS
propFperty:
PLX
LDA #!propF
RTS 
xtra0perty:
PLX
LDA #!xtra0
RTS
xtra1perty:
PLX
LDA #!xtra1
RTS
xtra2perty:
PLX
LDA #!xtra2
RTS
xtra3perty:
PLX
LDA #!xtra3
RTS
xtra4perty:
PLX
LDA #!xtra4
RTS
xtra5perty:
PLX
LDA #!xtra5
RTS
xtra6perty:
PLX
LDA #!xtra6
RTS
xtra7perty:
PLX
LDA #!xtra7
RTS
xtra8perty:
PLX
LDA #!xtra8
RTS
xtra9perty:
PLX
LDA #!xtra9
RTS
xtraAperty:
PLX
LDA #!xtraA
RTS
xtraBperty:
PLX
LDA #!xtraB
RTS
xtraCperty:
PLX
LDA #!xtraC
RTS
xtraDperty:
PLX
LDA #!xtraD
RTS
xtraEperty:
PLX
LDA #!xtraE
RTS
xtraFperty:
PLX
LDA #!xtraF
RTS 