;Mario teleports to the level set in this .asm
;by smkdan
;Act like tile 25
JMP MarioBelow : JMP MarioAbove : JMP MarioSide : JMP SpriteV : JMP SpriteH : JMP MarioCape : JMP MarioFireBall
;don't touch those

!LEVEL = $11F		;level dest
!PROPERTIES = $00	;See 7E:19B8 RAM map, minus the high bit
!BUTTON = $40 ; button to press.
	
MarioAbove: 
MarioSide: 
MarioBelow:
	LDA $16
	AND #!BUTTON
	BEQ SpriteV
	LDA $5B
	BEQ Horz

	LDX $97
	BRA Setup
Horz:
	LDX $95		;mario X pos high

Setup:
	PEA !LEVEL	;push teleport destination
	PLA		;low byte
	STA $19B8,x	;write exit table
	PLA		;high byte
	ORA #$04	;exit present
	ORA #!PROPERTIES	
	STA $19D8,x	;write high bit and properties

Teleport:
	LDA #$06	;teleport
	STA $71
	STZ $89
	STZ $88
	
SpriteV: 
SpriteH:
MarioCape: 
MarioFireBall:
	RTL