;=============;
;Mario Status ;
;=============;

!A = $0A : !B = $0B : !C = $0C : !D = $0D : !E = $0E : !F = $0F : !G = $10 : !H = $11 : !I = $12 : !J = $13 : !K = $14
!L = $15 : !M = $16 : !N = $17 : !O = $18 : !P = $19 : !Q = $1A : !R = $1B : !S = $1C : !T = $1D : !U = $1E : !V = $1F
!W = $20 : !X = $21 : !Y = $22 : !Z = $23

print "INIT ",pc
	RTL

print "MAIN ",pc
	PHX
	JSL DoMain
	PLX
	RTL
DoMain:
	LDA $75
	ORA $85
	BEQ .Skip
	JSL Water
.Skip
	LDA $1490
	BEQ +
	JSL Star
+
	LDA $187A
	BEQ +
	JSL Yoshi
+
	LDA $73
	BEQ +
	JSL Ducking
+
	LDA $74
	BEQ +
	JSL Climbing
+
	LDA $187A
	ORA $73
	ORA $74
	ORA $75
	ORA $85
	ORA $1490
	BNE .R
	LDA $19
	BEQ Small
	CMP #$01
	BEQ Big
	CMP #$02
	BEQ Cape
	CMP #$03
	BEQ Fire
	LDX #$04
-
	LDA #$FC
	STA $0EF9,x
	DEX
	BPL -
.R
	RTL

TblCape: db !C,!A,!P,!E,$FC
Cape:
	LDX #$04
-
	LDA TblCape,x
	STA $0EF9,x
	DEX
	BPL -
	RTL

TblFire: db !F,!I,!R,!E,$FC
Fire:
	LDX #$04
-
	LDA TblFire,x
	STA $0EF9,x
	DEX
	BPL -
	RTL

TblSmall: db !S,!M,!A,!L,!L
Small:
	LDX #$04
-
	LDA TblSmall,x
	STA $0EF9,x
	DEX
	BPL -
	RTL

TblBig: db !B,!I,!G,$FC,$FC
Big:
	LDX #$04
-
	LDA TblBig,x
	STA $0EF9,x
	DEX
	BPL -
	RTL


TblWater: db !W,!A,!T,!E,!R
Water:
	LDX #$04
-
	LDA TblWater,x
	STA $0EF9,x
	DEX
	BPL -
	RTL

TblStar: db !S,!T,!A,!R,$FC
Star:
	LDX #$04
-
	LDA TblStar,x
	STA $0EF9,x
	DEX
	BPL -
	RTL

TblYoshi: db !Y,!O,!S,!H,!I
Yoshi:
	LDX #$04
-
	LDA TblYoshi,x
	STA $0EF9,x
	DEX
	BPL -
	RTL

TblDuck: db !D,!U,!C,!K,$FC
Ducking:
	LDX #$04
-
	LDA TblDuck,x
	STA $0EF9,x
	DEX
	BPL -
	RTL

TblClimb: db !C,!L,!I,!M,!B
Climbing:
	LDX #$04
-
	LDA TblClimb,x
	STA $0EF9,x
	DEX
	BPL -
	RTL